#include "text.h"
#include "bg.h"

char *ltoa(long value, char *string, int radix)
{
	char tmp[33] = {0};
	char *tp = tmp;
	long i;
	unsigned long v;
	int sign;
	char *sp;

	if (string == 0) {
		return 0;
	}

	if (radix > 36 || radix <= 1) {
		return 0;
	}

	sign = (radix == 10 && value < 0);
	if (sign) {
		v = -value;
	} else {
		v = (unsigned long)value;  }

	while (v || tp == tmp) {
		i = v % radix;
		v = v / radix;
		if (i < 10) {
			*tp++ = i+'0';
		} else {
			*tp++ = i + 'a' - 10;
		}
	}

	sp = string;

	if (sign) {
		*sp++ = '-';
	}

	while (tp > tmp) {
		*sp++ = *--tp;
	}

	*sp = 0;

	return string;
}

// Writes the number passed to it to (x,y) tile of the bg passed to it by a pointer.
void TextWrite(int x,int y,int num,cBgBase* bg)
{
	char temp[10];
	ltoa(num,temp,10);
	TextWrite(x,y,temp,bg);
}

// Writes the string passed to it to (x,y) tile of the bg passed to it by a pointer.
void TextWrite(int x,int y,char *text,cBgBase* bg)
{
	int pos=0;

	while(text[pos]!=0)
	{
		if(text[pos]>=' '&&text[pos]<='~') // Within font range? (see font.bmp) 15<<12 means "choose palette 15", since that's where I put the font palette.
			bg->map[x+y*32+pos]=(text[pos]-32)|(15<<12);
		else // If not, return ' '
			bg->map[x+y*32+pos]=0;

		pos++;
	}
}
